// Generated by CoffeeScript 1.6.3
var apis, contributor, promise, _;

_ = require('lodash');

promise = require('when');

apis = {
  cpan: require('cpan-count'),
  gem: require('gem-count'),
  github: require('github-repos'),
  npm: require('npm-packages'),
  nuget: require('nuget-count')
};

contributor = function(identities) {
  var check, counts, deferred, error, have, need, success;
  if (identities == null) {
    identities = {};
  }
  deferred = promise.defer();
  counts = {};
  have = 0;
  need = (_.keys(identities)).length;
  check = function() {
    var action;
    ++have;
    action = have === need ? 'resolve' : 'notify';
    return deferred[action](counts);
  };
  success = function(platform, count) {
    counts[platform] = count;
    return check();
  };
  error = function(platform, err) {
    counts[platform] = err;
    return check();
  };
  _.each(identities, function(identity, platform) {
    var fn, _fn;
    fn = apis[platform];
    if (platform === 'github' && process.env.github_oauth_id && process.env.github_oauth_secret) {
      _fn = fn(identities[platform], process.env.github_oauth_id, process.env.github_oauth_secret);
    } else {
      _fn = fn(identities[platform]);
    }
    return _fn.then(function(count) {
      return success(platform, count);
    }, function(err) {
      return error(platform, err);
    });
  });
  return deferred.promise;
};

contributor.support = _.keys(apis);

module.exports = contributor;
